#include "RTClib.h"

RTC_DS3231 rtc;

int my_str [16];
int tempC ;
int d;

int val = 0;
int prestate1 = 0;
int prestate2 = 0;
int okCount = 0;
int new_time [14];

const int up = 7;
const int down = 8;
const int ok = 9;
const int save = 10;

int latchPin = 12;  //Pin connected to ST_CP of 1st 74595
int clockPin = 13;  //Pin connected to SH_CP of 1st 74595
int dataPin = 11;   //Pin connected to DS of 1st 74595

int digit_code = 0;
int k = 0;
int week_day;

int latchPin2 = 5;  //Pin connected to ST_CP of 2nd 74595
int clockPin2 = 6;  //Pin connected to SH_CP of 2nd 74595
int dataPin2 = 4;  //Pin connected to DS of 2nd 74595

int latchPin3 = A0;  //Pin connected to ST_CP of 2nd 74595
int clockPin3 = A1;  //Pin connected to SH_CP of 2nd 74595
int dataPin3 = A2;  //Pin connected to DS of 2nd 74595

void setup() {
  rtc.begin();
  //set pins to output so you can control the shift register
  pinMode(latchPin, OUTPUT);
  pinMode(clockPin, OUTPUT);
  pinMode(dataPin, OUTPUT);
  rtc.adjust(DateTime(2021, 5, 9, 23, 59, 41));
  pinMode(latchPin2, OUTPUT);
  pinMode(clockPin2, OUTPUT);
  pinMode(dataPin2, OUTPUT);
  pinMode(latchPin3, OUTPUT);
  pinMode(clockPin3, OUTPUT);
  pinMode(dataPin3, OUTPUT);
  pinMode(2, INPUT_PULLUP);
  pinMode(7, INPUT_PULLUP);
  pinMode(8, INPUT_PULLUP);
  pinMode(9, INPUT_PULLUP);
  pinMode(10, INPUT_PULLUP);
  attachInterrupt(0, count, CHANGE);
}

void loop() {
  if (!digitalRead(ok) == HIGH) {
    setting();
  }

  clock_run();
}

void count() {
  okCount++;
}

void setting () {
  while (digitalRead(save) == HIGH) {
    while (okCount == 0) {
      if (digitalRead(up) == LOW && prestate1 == 0 && val < 9) {
        val++;
        prestate1 = 1;
      } else if (digitalRead(up) == HIGH)
        prestate1 = 0;
      if (digitalRead(down) == LOW && prestate2 == 0 && val > 0) {
        val--;
        prestate2 = 1;
      } else if (digitalRead(down) == HIGH)
        prestate2 = 0;
      digitalWrite(latchPin, LOW);
      shiftOut(dataPin, clockPin, LSBFIRST, digits(val));
      digitalWrite(latchPin, HIGH);
      seg3();
      new_time[0] = val;
    }
    while (okCount == 1) {
      if (digitalRead(up) == LOW && prestate1 == 0 && val < 9) {
        val++;
        prestate1 = 1;
      } else if (digitalRead(up) == HIGH)
        prestate1 = 0;
      if (digitalRead(down) == LOW && prestate2 == 0 && val > 0) {
        val--;
        prestate2 = 1;
      } else if (digitalRead(down) == HIGH)
        prestate2 = 0;
      digitalWrite(latchPin, LOW);
      shiftOut(dataPin, clockPin, LSBFIRST, digits(val));
      digitalWrite(latchPin, HIGH);
      seg4();
      new_time[1] = val;
    }
  }
  //rtc.adjust(DateTime(2021, 5, 1, 23, 59, 41));
}



void clock_run() {
  DateTime now = rtc.now();

  if (now.hour() < 10) {
    my_str[2] = 0;
    my_str[3] = now.hour();
  } else {
    my_str[2] = now.hour() / 10;
    my_str[3] = now.hour() % 10;
  }
  if (now.minute() < 10) {
    my_str[4] = 0;
    my_str[5] = now.minute();
  } else {
    my_str[4] = now.minute() / 10;
    my_str[5] = now.minute() % 10;
  }

  if (now.second() < 10) {
    my_str[6] = 0;
    my_str[7] = now.second();
  } else {
    my_str[6] = now.second() / 10;
    my_str[7] = now.second() % 10;
  }

  if (now.day() < 10) {
    my_str[8] = 0;
    my_str[9] = now.day();
  } else {
    my_str[8] = now.day() / 10;
    my_str[9] = now.day() % 10;
  }
  if (now.month() < 10) {
    my_str[10] = 0;
    my_str[11] = now.month();
  } else {
    my_str[10] = now.month() / 10;
    my_str[11] = now.month() % 10;
  }
  my_str [12] = now.year() / 1000;
  my_str [13] = (now.year() / 100) % 10;
  my_str [14] = (now.year() / 10) % 10;
  my_str [15] = now.year() % 10;

  tempC = rtc.getTemperature();
  my_str [0] = tempC / 10;
  my_str [1] = tempC % 10;

  d = now.dayOfTheWeek();

  digitalWrite(latchPin3, LOW);
  shiftOut(dataPin3, clockPin3, LSBFIRST, dayofweek(d));
  digitalWrite(latchPin3, HIGH);

  digitalWrite(latchPin, LOW);
  shiftOut(dataPin, clockPin, LSBFIRST, digits(my_str [0]));
  digitalWrite(latchPin, HIGH);
  seg1();

  digitalWrite(latchPin, LOW);
  shiftOut(dataPin, clockPin, LSBFIRST, digits(my_str [1]));
  digitalWrite(latchPin, HIGH);
  seg2();

  digitalWrite(latchPin, LOW);
  shiftOut(dataPin, clockPin, LSBFIRST, digits(my_str[2]));
  digitalWrite(latchPin, HIGH);
  seg3();

  digitalWrite(latchPin, LOW);
  shiftOut(dataPin, clockPin, LSBFIRST, digits(my_str[3]));
  digitalWrite(latchPin, HIGH);
  seg4();

  digitalWrite(latchPin, LOW);
  shiftOut(dataPin, clockPin, LSBFIRST, digits(my_str[4]));
  digitalWrite(latchPin, HIGH);
  seg5();

  digitalWrite(latchPin, LOW);
  shiftOut(dataPin, clockPin, LSBFIRST, digits(my_str[5]));
  digitalWrite(latchPin, HIGH);
  seg6();

  digitalWrite(latchPin, LOW);
  shiftOut(dataPin, clockPin, LSBFIRST, digits(my_str[6]));
  digitalWrite(latchPin, HIGH);
  seg7();

  digitalWrite(latchPin, LOW);
  shiftOut(dataPin, clockPin, LSBFIRST, digits(my_str[7]));
  digitalWrite(latchPin, HIGH);
  seg8();

  digitalWrite(latchPin, LOW);
  shiftOut(dataPin, clockPin, LSBFIRST, digits(my_str[8]));
  digitalWrite(latchPin, HIGH);
  seg9();

  digitalWrite(latchPin, LOW);
  shiftOut(dataPin, clockPin, LSBFIRST, digits(my_str[9]));
  digitalWrite(latchPin, HIGH);
  seg10();

  digitalWrite(latchPin, LOW);
  shiftOut(dataPin, clockPin, LSBFIRST, digits(my_str[10]));
  digitalWrite(latchPin, HIGH);
  seg11();

  digitalWrite(latchPin, LOW);
  shiftOut(dataPin, clockPin, LSBFIRST, digits(my_str[11]));
  digitalWrite(latchPin, HIGH);
  seg12();

  digitalWrite(latchPin, LOW);
  shiftOut(dataPin, clockPin, LSBFIRST, digits(my_str[12]));
  digitalWrite(latchPin, HIGH);
  seg13();

  digitalWrite(latchPin, LOW);
  shiftOut(dataPin, clockPin, LSBFIRST, digits(my_str[13]));
  digitalWrite(latchPin, HIGH);
  seg14();

  digitalWrite(latchPin, LOW);
  shiftOut(dataPin, clockPin, LSBFIRST, digits(my_str[14]));
  digitalWrite(latchPin, HIGH);
  seg15();

  digitalWrite(latchPin, LOW);
  shiftOut(dataPin, clockPin, LSBFIRST, digits(my_str[15]));
  digitalWrite(latchPin, HIGH);
  seg16();

}

int digits(int x)
{
  switch (x)
  {
    case 0:
      digit_code = 252;
      break;
    case 1:
      digit_code = 96;
      break;
    case 2:
      digit_code = 218;
      break;
    case 3:
      digit_code = 242;
      break;
    case 4:
      digit_code = 102;
      break;
    case 5:
      digit_code = 182;
      break;
    case 6:
      digit_code = 190;
      break;
    case 7:
      digit_code = 224;
      break;
    case 8:
      digit_code = 254;
      break;
    case 9:
      digit_code = 246;
      break;
  }
  return digit_code;
}
void seg1() {
  digitalWrite(latchPin2, LOW); shiftOut(dataPin2, clockPin2, LSBFIRST, (0xFF7F >> 8)); shiftOut(dataPin2, clockPin2, LSBFIRST, 0xFF7F); digitalWrite(latchPin2, HIGH); digitalWrite(latchPin2, LOW); shiftOut(dataPin2, clockPin2, LSBFIRST, (0xFFFF >> 8)); shiftOut(dataPin2, clockPin2, LSBFIRST, 0xFFFF); digitalWrite(latchPin2, HIGH);
}
void seg2() {
  digitalWrite(latchPin2, LOW); shiftOut(dataPin2, clockPin2, LSBFIRST, (0xFFBF >> 8)); shiftOut(dataPin2, clockPin2, LSBFIRST, 0xFFBF); digitalWrite(latchPin2, HIGH); digitalWrite(latchPin2, LOW); shiftOut(dataPin2, clockPin2, LSBFIRST, (0xFFFF >> 8)); shiftOut(dataPin2, clockPin2, LSBFIRST, 0xFFFF); digitalWrite(latchPin2, HIGH);
}
void seg3() {
  digitalWrite(latchPin2, LOW); shiftOut(dataPin2, clockPin2, LSBFIRST, (0xFFDF >> 8)); shiftOut(dataPin2, clockPin2, LSBFIRST, 0xFFDF); digitalWrite(latchPin2, HIGH); digitalWrite(latchPin2, LOW); shiftOut(dataPin2, clockPin2, LSBFIRST, (0xFFFF >> 8)); shiftOut(dataPin2, clockPin2, LSBFIRST, 0xFFFF); digitalWrite(latchPin2, HIGH);
}
void seg4() {
  digitalWrite(latchPin2, LOW); shiftOut(dataPin2, clockPin2, LSBFIRST, (0xFFEF >> 8)); shiftOut(dataPin2, clockPin2, LSBFIRST, 0xFFEF); digitalWrite(latchPin2, HIGH); digitalWrite(latchPin2, LOW); shiftOut(dataPin2, clockPin2, LSBFIRST, (0xFFFF >> 8)); shiftOut(dataPin2, clockPin2, LSBFIRST, 0xFFFF); digitalWrite(latchPin2, HIGH);
}
void seg5() {
  digitalWrite(latchPin2, LOW); shiftOut(dataPin2, clockPin2, LSBFIRST, (0xFFF7 >> 8)); shiftOut(dataPin2, clockPin2, LSBFIRST, 0xFFF7); digitalWrite(latchPin2, HIGH); digitalWrite(latchPin2, LOW); shiftOut(dataPin2, clockPin2, LSBFIRST, (0xFFFF >> 8)); shiftOut(dataPin2, clockPin2, LSBFIRST, 0xFFFF); digitalWrite(latchPin2, HIGH);
}
void seg6() {
  digitalWrite(latchPin2, LOW); shiftOut(dataPin2, clockPin2, LSBFIRST, (0xFFFB >> 8)); shiftOut(dataPin2, clockPin2, LSBFIRST, 0xFFFB); digitalWrite(latchPin2, HIGH); digitalWrite(latchPin2, LOW); shiftOut(dataPin2, clockPin2, LSBFIRST, (0xFFFF >> 8)); shiftOut(dataPin2, clockPin2, LSBFIRST, 0xFFFF); digitalWrite(latchPin2, HIGH);
}
void seg7() {
  digitalWrite(latchPin2, LOW); shiftOut(dataPin2, clockPin2, LSBFIRST, (0xFFFD >> 8)); shiftOut(dataPin2, clockPin2, LSBFIRST, 0xFFFD); digitalWrite(latchPin2, HIGH); digitalWrite(latchPin2, LOW); shiftOut(dataPin2, clockPin2, LSBFIRST, (0xFFFF >> 8)); shiftOut(dataPin2, clockPin2, LSBFIRST, 0xFFFF); digitalWrite(latchPin2, HIGH);
}
void seg8() {
  digitalWrite(latchPin2, LOW); shiftOut(dataPin2, clockPin2, LSBFIRST, (0xFFFE >> 8)); shiftOut(dataPin2, clockPin2, LSBFIRST, 0xFFFE); digitalWrite(latchPin2, HIGH); digitalWrite(latchPin2, LOW); shiftOut(dataPin2, clockPin2, LSBFIRST, (0xFFFF >> 8)); shiftOut(dataPin2, clockPin2, LSBFIRST, 0xFFFF); digitalWrite(latchPin2, HIGH);
}
void seg9() {
  digitalWrite(latchPin2, LOW); shiftOut(dataPin2, clockPin2, LSBFIRST, (0x7FFF >> 8)); shiftOut(dataPin2, clockPin2, LSBFIRST, 0x7FFF); digitalWrite(latchPin2, HIGH); digitalWrite(latchPin2, LOW); shiftOut(dataPin2, clockPin2, LSBFIRST, (0xFFFF >> 8)); shiftOut(dataPin2, clockPin2, LSBFIRST, 0xFFFF); digitalWrite(latchPin2, HIGH);
}
void seg10() {
  digitalWrite(latchPin2, LOW); shiftOut(dataPin2, clockPin2, LSBFIRST, (0xBFFF >> 8)); shiftOut(dataPin2, clockPin2, LSBFIRST, 0xBFFF); digitalWrite(latchPin2, HIGH); digitalWrite(latchPin2, LOW); shiftOut(dataPin2, clockPin2, LSBFIRST, (0xFFFF >> 8)); shiftOut(dataPin2, clockPin2, LSBFIRST, 0xFFFF); digitalWrite(latchPin2, HIGH);
}
void seg11() {
  digitalWrite(latchPin2, LOW); shiftOut(dataPin2, clockPin2, LSBFIRST, (0xDFFF >> 8)); shiftOut(dataPin2, clockPin2, LSBFIRST, 0xDFFF); digitalWrite(latchPin2, HIGH); digitalWrite(latchPin2, LOW); shiftOut(dataPin2, clockPin2, LSBFIRST, (0xFFFF >> 8)); shiftOut(dataPin2, clockPin2, LSBFIRST, 0xFFFF); digitalWrite(latchPin2, HIGH);
}
void seg12() {
  digitalWrite(latchPin2, LOW); shiftOut(dataPin2, clockPin2, LSBFIRST, (0xEFFF >> 8)); shiftOut(dataPin2, clockPin2, LSBFIRST, 0xEFFF); digitalWrite(latchPin2, HIGH); digitalWrite(latchPin2, LOW); shiftOut(dataPin2, clockPin2, LSBFIRST, (0xFFFF >> 8)); shiftOut(dataPin2, clockPin2, LSBFIRST, 0xFFFF); digitalWrite(latchPin2, HIGH);
}
void seg13() {
  digitalWrite(latchPin2, LOW); shiftOut(dataPin2, clockPin2, LSBFIRST, (0xF7FF >> 8)); shiftOut(dataPin2, clockPin2, LSBFIRST, 0xF7FF); digitalWrite(latchPin2, HIGH); digitalWrite(latchPin2, LOW); shiftOut(dataPin2, clockPin2, LSBFIRST, (0xFFFF >> 8)); shiftOut(dataPin2, clockPin2, LSBFIRST, 0xFFFF); digitalWrite(latchPin2, HIGH);
}
void seg14() {
  digitalWrite(latchPin2, LOW); shiftOut(dataPin2, clockPin2, LSBFIRST, (0xFBFF >> 8)); shiftOut(dataPin2, clockPin2, LSBFIRST, 0xFBFF); digitalWrite(latchPin2, HIGH); digitalWrite(latchPin2, LOW); shiftOut(dataPin2, clockPin2, LSBFIRST, (0xFFFF >> 8)); shiftOut(dataPin2, clockPin2, LSBFIRST, 0xFFFF); digitalWrite(latchPin2, HIGH);
}
void seg15() {
  digitalWrite(latchPin2, LOW); shiftOut(dataPin2, clockPin2, LSBFIRST, (0xFDFF >> 8)); shiftOut(dataPin2, clockPin2, LSBFIRST, 0xFDFF); digitalWrite(latchPin2, HIGH); digitalWrite(latchPin2, LOW); shiftOut(dataPin2, clockPin2, LSBFIRST, (0xFFFF >> 8)); shiftOut(dataPin2, clockPin2, LSBFIRST, 0xFFFF); digitalWrite(latchPin2, HIGH);
}
void seg16() {
  digitalWrite(latchPin2, LOW); shiftOut(dataPin2, clockPin2, LSBFIRST, (0xFEFF >> 8)); shiftOut(dataPin2, clockPin2, LSBFIRST, 0xFEFF); digitalWrite(latchPin2, HIGH); digitalWrite(latchPin2, LOW); shiftOut(dataPin2, clockPin2, LSBFIRST, (0xFFFF >> 8)); shiftOut(dataPin2, clockPin2, LSBFIRST, 0xFFFF); digitalWrite(latchPin2, HIGH);
}


int dayofweek (int y)
{
  switch (y)
  {
    case 0:
      week_day = B10000000;
      break;
    case 1:
      week_day = B01000000;
      break;
    case 2:
      week_day = B00100000;
      break;
    case 3:
      week_day = B00010000;
      break;
    case 4:
      week_day = B00001000;
      break;
    case 5:
      week_day = B00000100;
      break;
    case 6:
      week_day = B00000010;
      break;
  }
  return week_day;
}
